#version 330 core

#define M_PI	3.14159265358979323846f
#define M_PIH	(3.14159265358979323846f/2.f)

in  vec4 color;
out vec4 outputF;

vec3 hsv2rgb(vec3 c)
{
	vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
	vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
	return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}
//----------------------------------------------------------------
// TODO:
// 1) Compute HSV [0.0, 1.0] from the input position.
// 2) Convert them to RGB using the given function to compute the output color.
//----------------------------------------------------------------

void main()
{
	float h = 0.f;

	// Find the angle between positive x and the vector
	h = atan(color.z, color.x);
	if(h < 0.0f)
		h += 2*M_PI;
	h /= 2*M_PI;

	float v = 1.f - color.y;
	float s = length(vec2(color.x, color.z)) / v; // Length of the vector from current position in the x-z plane to the center of the cone

	outputF = vec4(hsv2rgb(vec3(h, s, v)), 1.0f);
}
